# !! DEPRECATED !! Please use the official component at https://gitlab.com/gitlab-org/components/danger-review !! DEPRECATED !!

# This job supports the following variables:
# - DANGER_IMAGE: (Optional) Image used to run danger. Defaults to `"ruby:3.0"`.
# - DANGER_GITLAB_API_TOKEN: (Optional) A project access token with `api` scope.
# - DANGER_DANGERFILE: (Optional) Location of the Dangerfile. Defauls to `"Dangerfile"`.
# - GITLAB_DANGERFILES_VERSION: (Optional) Version requirement for `gitlab-dangerfiles`. Latest version if empty.
danger-review:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  image: $DANGER_IMAGE
  stage: test
  needs: []
  variables:
    DANGER_IMAGE: "ruby:3.0"
  retry:
    max: 2
    when:
      - unknown_failure
      - api_failure
      - runner_system_failure
      - stuck_or_timeout_failure
  before_script:
    - '[[ ! -f "Gemfile" ]] && bundle init && bundle add gitlab-dangerfiles --version "$GITLAB_DANGERFILES_VERSION"'
    - '[[ ! -f "Gemfile.lock" ]] || bundle config set --local frozen "true"'
    - bundle install
  script:
    - >
      echo "!! DEPRECATED !! Please use the official component at https://gitlab.com/gitlab-org/components/danger-review !! DEPRECATED !!"
    # ${DANGER_DANGERFILE} is used by Jihulab for customizing danger support: https://jihulab.com/gitlab-cn/gitlab/-/blob/main-jh/jh/.gitlab-ci.yml
    # Fetch the source branch when the source and target project of the merge
    # request are different (i.e. merge request is from a fork), or when using
    # using the dry_run command. In either case, danger may have trouble finding
    # $CI_MERGE_REQUEST_SOURCE_BRANCH_SHA when the pipeline runs on an
    # auto-squashed or an auto-rebased merge train ref. Note that we cannot use
    # $CI_REPOSITORY_URL because in merge trains, that will be the target
    # project's URL, but as explained, we need the source project.
    - >
      if [[ "$CI_MERGE_REQUEST_PROJECT_URL" != "$CI_MERGE_REQUEST_SOURCE_PROJECT_URL" || -z "${DANGER_GITLAB_API_TOKEN}" ]]; then
        git fetch "${CI_SERVER_PROTOCOL}://gitlab-ci-token:${CI_JOB_TOKEN}@${CI_SERVER_HOST}:${CI_SERVER_PORT}/${CI_MERGE_REQUEST_SOURCE_PROJECT_PATH}.git" "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      fi
    - >
      if [ -z "${DANGER_GITLAB_API_TOKEN}" ]; then
        echo '`DANGER_GITLAB_API_TOKEN` is not set. Skipping CI source GitLab and falling back to "local only git repo".'
        unset GITLAB_CI;
        # We need to base SHA to help danger determine the base commit for this shallow clone.
        bundle exec danger dry_run --fail-on-errors=true --verbose --base="${CI_MERGE_REQUEST_DIFF_BASE_SHA}" --head="${CI_MERGE_REQUEST_SOURCE_BRANCH_SHA:-$CI_COMMIT_SHA}" --dangerfile="${DANGER_DANGERFILE:-Dangerfile}";
      else
        danger_id=$(echo -n ${DANGER_GITLAB_API_TOKEN} | md5sum | awk '{print $1}' | cut -c5-10);
        bundle exec danger --fail-on-errors=true --verbose --danger_id="${danger_id}" --dangerfile="${DANGER_DANGERFILE:-Dangerfile}";
      fi
